#include <iostream>
#include <stdio.h>
#include <math.h>
#include<stdlib.h>
#include<ctype.h>
#include<string.h>
#include<algorithm>
#include<vector>
#include<string>
#include<queue>
#include<stack>
#include<map>
#include<set>
#include<list>

using namespace std;

#define FOR(i, a, b) for(int i=a; i<b; ++i)
#define FORD(i, a, b) for(int i=a-1; i>b; --i)

int L, S[4];
int ss[4][2100];

map<pair<int, int>, int> cache;

long long rek(int depth, int left)
{
	if (left < 0)
		return 0;

	if (depth == 4)
		return 1;

	map<pair<int, int>, int>::iterator itr =
		cache.find(make_pair(depth, left));
	if (itr != cache.end())
		return itr->second;

	long long res = 0;
	for (int i = 0; i < S[depth]; ++i)
		if (ss[depth][i] <= left)
			res += rek(depth + 1, left - ss[depth][i]);

	cache[make_pair(depth, left)] = res;
	return res;
}

struct Border
{
	int a[4];
};

void push_(Border& b, int row, int& sum)
{
	while (b.a[row] + 1 < S[row])
	{
		if (sum - ss[row][b.a[row]] + ss[row][b.a[row] + 1] <= L)
		{
			sum = sum - ss[row][b.a[row]] + ss[row][b.a[row] + 1];
			++b.a[row];
		}
		else
			break;
	}
}

void push(Border& b, vector<int> order, int& sum)
{
	FOR(idx, 1, 5)
	{
		FOR(i, 0, 4)
			if (order[i] == idx)
				push_(b, i, sum);
	}

}

int main()
{
	/*	srand(time(NULL));
			int tmp = 1;
			while (tmp--) {

			L = 10e8;

			if (L == 0) break;

			FOR(i, 0, 4)
			{
			S[i] = 2000;

			FOR(j, 0, 2000) ss[i][j] = rand() % 500000;
			}

			sort(ss[0], ss[0]+S[0]);
			sort(ss[1], ss[1]+S[1]);
			sort(ss[2], ss[2]+S[2]);
			sort(ss[3], ss[3]+S[3]);

			cout << rek(0, L) << endl;
			cache.clear();
			}*/

	while (scanf("%d%d%d%d%d", &L, &S[0], &S[1], &S[2], &S[3]))
	{
		if (L == 0) break;

		/*		FOR(i, 0, 4)
					{
					S[i] = 2000;

					FOR(j, 0, 2000) ss[i][j] = rand() % 500000;
					}*/

		FOR(i,0,S[0]) scanf("%d", &ss[0][i]);
		FOR(i,0,S[1]) scanf("%d", &ss[1][i]);
		FOR(i,0,S[2]) scanf("%d", &ss[2][i]);
		FOR(i,0,S[3]) scanf("%d", &ss[3][i]);

		sort(ss[0], ss[0]+S[0]);
		sort(ss[1], ss[1]+S[1]);
		sort(ss[2], ss[2]+S[2]);
		sort(ss[3], ss[3]+S[3]);

		FOR(i, 0, S[0]) cout << ss[0][i] << endl;

		vector<int> order;

		FOR(i, 1, 5) order.push_back(i);

		vector<Border> border;

		do
		{
			Border b;
			int sum = 0;
			FOR(i, 0, 4)
			{
				sum += ss[i][0];
				b.a[i] = 0;
			}


			push(b, order, sum);
			border.push_back(b);

		} while (next_permutation(order.begin(), order.end()));

		cout << border.size() << "!" << endl;
		long long res = 0;

		FOR(choose, 1, 25)
		{

			vector<int> mask(24);
			FOR(i, 0, choose) mask[i] = 1;
			FOR(i, choose, 24) mask[i] = 0;
			sort(mask.begin(), mask.end());

			Border b;
			do
			{
				FOR(i, 0, 4) b.a[i] = S[i] - 1;

				FOR(i, 0, 24)
					if (mask[i])
					{
						FOR(j, 0, 4)
						{

							b.a[j] = min(b.a[j], border[i].a[j]);

						}

					}


				long long cres = 1;
				FOR(i, 0, 4)
					cres *= (b.a[i] + 1);

				if (choose % 2)
					res += cres;
				else
					res -= cres;

			} while (next_permutation(mask.begin(), mask.end()));
		}

		cout << res << endl;
	}

	return 0;
}
